import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import './index.scss';
import { init, plugins } from '@alilc/lowcode-engine';
import ComponentsPane from '@alilc/lowcode-plugin-components-pane';
import CodeGenPlugin from '../';
(function () {
  var _main = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return plugins.register(Object.assign(function (ctx) {
              return {
                name: 'editor-init',
                init: function init() {
                  return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                    var assets, schema;
                    return _regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return import('./assets.json');

                          case 2:
                            assets = _context.sent;
                            // 设置物料描述
                            ctx.material.setAssets(assets); // 加载 schema

                            _context.next = 6;
                            return import('./schema.json');

                          case 6:
                            schema = _context.sent;
                            // 加载 schema
                            ctx.project.openDocument(schema);

                          case 8:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }))();
                }
              };
            }, {
              pluginName: 'editorInit'
            }));

          case 2:
            _context3.next = 4;
            return plugins.register(Object.assign(function (ctx) {
              return {
                name: 'builtin-plugin-registry',
                init: function init() {
                  return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
                    var _componentsPane$disab;

                    var skeleton, project, componentsPane;
                    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            skeleton = ctx.skeleton, project = ctx.project; // 注册组件面板

                            // 注册组件面板
                            componentsPane = skeleton.add({
                              area: 'leftArea',
                              type: 'PanelDock',
                              name: 'componentsPane',
                              content: ComponentsPane,
                              contentProps: {},
                              props: {
                                align: 'top',
                                icon: 'zujianku',
                                description: '组件库'
                              }
                            });
                            componentsPane === null || componentsPane === void 0 ? void 0 : (_componentsPane$disab = componentsPane.disable) === null || _componentsPane$disab === void 0 ? void 0 : _componentsPane$disab.call(componentsPane);
                            project.onSimulatorRendererReady(function () {
                              var _componentsPane$enabl;

                              componentsPane === null || componentsPane === void 0 ? void 0 : (_componentsPane$enabl = componentsPane.enable) === null || _componentsPane$enabl === void 0 ? void 0 : _componentsPane$enabl.call(componentsPane);
                            });

                          case 4:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }))();
                }
              };
            }, {
              pluginName: 'builtinPluginRegistry'
            }));

          case 4:
            _context3.next = 6;
            return plugins.register(CodeGenPlugin);

          case 6:
            // 初始化设计器
            init(document.getElementById('lce-container'), {
              // designMode: 'live',
              // locale: 'zh-CN',
              enableCondition: true,
              enableCanvasLock: true,
              // 默认绑定变量
              supportVariableGlobally: true
            });

          case 7:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  function main() {
    return _main.apply(this, arguments);
  }

  return main;
})()();